<!DOCTYPE html>
<html>
    <head>
        <title>
            Creación de Páginas Web Nivel 2
        </title>
        <link rel="stylesheet" type="text/css" href="css/index_style.css"/>
        <link  rel="stylesheet" href="https://fonts.googleapis.com/css?family=Karla:400,400i,700,700i&ampdisplay=swap">
    </head>
    <body>
        <div id="whole">
            <div id="upper">
                <h1>
                    CREACIÓN DE PÁGINAS WEB NIVEL 2
                </h1>
            </div>
            <div id="middle">
                <div id="lateral">
                    <center>
                        <h5>
                            TABLA DE CONTENIDO
                        </h5> 
                    </center>
                    <ul>
                        <li>
                            <a href="#funciones">
                                Funciones
                            </a>
                        </li>
                        <li>
                            <a href="#globales">
                                Variables Locales y Globales
                            </a>
                        </li>
                        <li>
                            <a href="#heredadas">
                                Funciones Heredadas
                            </a>
                        </li>
                        <li>
                            <a href="#creadas">
                                Funciones creadas
                            </a>
                        </li>
                    </ul>
                </div>
                <div id="main">
                    <h2>
                        SESIÓN 1: FUNCIONES
                    </h2>
                    <h3 id="funciones">
                        Funciones
                    </h3>
                    <p align="justify">
                      En computación, una subrutina o subprograma (también llamada procedimiento, función o rutina), como idea general, se presenta como un subalgoritmo que forma parte del algoritmo principal, el cual permite resolver una tarea específica. Algunos lenguajes de programación, como Visual Basic.NET o Fortran, utilizan el nombre función para referirse a subrutinas que devuelven un valor.
                    <p align="justify">
                      Desde un punto de vista práctico, podemos decir que una función es una parte de un programa (subrutina) con un nombre, que puede ser invocada (llamada a ejecución) desde otras partes tantas veces como se desee. Un bloque de código que puede ser ejecutado como una unidad funcional. Opcionalmente puede recibir valores; se ejecuta y puede devolver un valor. Desde el punto de vista de la organización, podemos decir que una función es algo que permite un cierto orden en una maraña de algoritmos.
                    <p align="justify">
                      Las funciones son la parte central de la programación. Algunos lenguajes, como Pascal, distinguen entre procedimientos ("Procedures") y funciones. En C++ las funciones desempeñan ambos papeles, aunque en cierto modo, los ficheros desempeñan algunas funcionalidades de lo que, en otros lenguajes como Modula-2, se denominan módulos. Otra diferencia substancial es que C++ no permite el anidamiento de funciones, es decir, definir funciones dentro de otras. En C++ todas las funciones se definen a nivel de fichero, con lo que tienen ámbito global al fichero. 
                    <h3 id="globales">
                        Variables Locales y Globales
                    </h3>
                    <p align="justify">
                      Las reglas de ámbito de un lenguaje son las reglas que controlan si un fragmento de código conoce o tiene acceso a otro fragmento de código o de datos.
                    <p align="justify">
                      Una variable local es aquella cuyo ámbito se restringe a la función que la ha declarado se dice entonces que la variable es local a esa función. Esto implica que esa variable sólo va a poder ser manipulada en dicha sección, y no se podrá hacer referencia fuera de dicha sección. Cualquier variable que se defina dentro de las llaves del cuerpo de una función se interpreta como una variable local a esa función.
                    <p align="justify">
                      Cuando una variable x es local a una función func1, significa que la función func1 es la propietaria de dicha variable, y puede acceder a ella y modificarla. Si cualquier otra función del programa necesita conocer el valor de la variable x, es la función func1 la que debe transferir el valor de x a través del paso de argumentos en la llamada a la función. Si además esta función desea modificar el valor de dicha variable, entonces tendrá que devolver el nuevo valor a func1, y será func1 quien se encargue de asignar el valor devuelto a su variable x.
                    <p align="justify">
                      El argumento formal (los veremos en la siguiente sección) ámbito de un argumento formal es el mismo que el de una variable local; el argumento formal definido en la cabecera de una función sólo podrá ser accedido dentro del cuerpo de dicha función, y no en otros lugares del programa.
                    <p align="justify">
                      Una variable global es aquella que se define fuera del cuerpo de cualquier función, normalmente al principio del programa, después de la definición de los archivos de biblioteca (#include), de la definición de constantes simbólicas y antes de cualquier función. El ámbito de una variable global son todas las funciones que componen el programa, cualquier función puede acceder a dichas variables para leer y escribir en ellas. Es decir, se puede hacer referencia a su dirección de memoria en cualquier parde del programa.
                    <h3 id="heredadas">
                        Funciones Heredadas
                    </h3>
                    <p align="justify">
                      Un módulo (o biblioteca) es una colección de definiciones de variables, funciones y tipos (entre otras cosas) que pueden ser importadas para ser usadas desde cualquier programa.
                    <p align="justify">
                      Ya hemos visto algunos ejemplos de cómo usar módulos, particularmente el módulo matemático, del que podemos importar funciones como la exponencial y el coseno, y las constantes π y e:
                    <p align="justify">
                      Las ventajas de usar módulos son: las funciones y variables deben ser definidas sólo una vez, y luego pueden ser utilizadas en muchos programas sin necesidad de reescribir el código; permiten que un programa pueda ser organizado en varias secciones lógicas, puestas cada una en un archivo separado; hacen más fácil compartir componentes con otros programadores.
                    <p align="justify">
                      Python viene «de fábrica» con muchos módulos listos para ser usados. Además, es posible descargar de internet e instalar módulos prácticamente para hacer cualquier cosa. Por último, aprenderemos a crear nuestros propios módulos.
                    <h3 id="creadas">
                         Funciones creadas
                    </h3>
                    <p align="justify">
                      Las funciones no son lo mismo que los procedimientos. Una función siempre devuelve un valor, pero un procedimiento, puede o no puede devolver un valor.
                    <p align="justify">
                      Para devolver un valor especifico distinto del predeterminado, una función debe tener una sentencia return, que especifique el valor a devolver. Una función sin una instrucción return devolverá el valor predeterminado. En el caso de un constructor llamado con la palabra clave new, el valor predeterminado es el valor de su parametro. Para el resto de funciones, el valor predeterminado es undefined.
                    <p align="justify">
                      Los parámetros en la llamada a una función son los argumentos de la función. Los argumentos se pasan a las funciones por valor. Si la función cambia el valor de un argumento, este cambio no se refleja globalmente ni en la llamada de la función. Sin embargo, las referenias a objetos también son valores, y son especiales: si la función cambia las propiedades del objeto referenciado, ese cambio es visible fuera de la función.
                    <p align="justify">
                      La palabra clave this no hace referencia a la función que está ejecutandose actualmente, por lo que debes referirte a los objetos Function por nombre, incluso dentro del cuerpo de la función. Como alternativa, puedes utilizar la propiedad arguments.callee (que no se recomienda).
                </div>
            </div>
            <div id="footer">
                Página creada por Víctor Alfonso Mantilla Villamizar. 2019<br>Correo electrónico: vmantillav@gmail.com
            </div>
        </div>
    </body>
</html>
